package moe.odango.index.entity

import io.requery.*
import moe.odango.index.utils.EntityHelper
import moe.odango.index.utils.InfoSource
import moe.odango.index.utils.helper
import java.util.*

@Entity
interface AnimeGenre : Persistable {
    @get:Key
    val id: UUID

    @get:ManyToOne
    @get:ForeignKey
    val anime: Anime

    @get:ManyToOne
    @get:ForeignKey
    val genre: Genre

    val source: InfoSource

    companion object : EntityHelper<AnimeGenreEntity> by helper(::AnimeGenreEntity, {
        setId(UUID.randomUUID())
    })
}
