package moe.odango.index.entity

import io.requery.*
import moe.odango.index.utils.EntityHelper
import moe.odango.index.utils.InfoSource
import moe.odango.index.utils.ProducerFunction
import moe.odango.index.utils.helper
import java.util.*

@Entity
interface AnimeProducer : Persistable {
    @get:Key
    val id: UUID

    @get:ManyToOne
    val anime: Anime

    @get:ManyToOne
    val producer: Producer

    @get:Column(name = "producer_function")
    var function: ProducerFunction
    val source: InfoSource

    companion object : EntityHelper<AnimeProducerEntity> by helper(::AnimeProducerEntity, {
        setId(UUID.randomUUID())
    })
}
