package moe.odango.index.entity

import io.requery.*
import moe.odango.index.utils.EntityHelper
import moe.odango.index.utils.InfoSource
import moe.odango.index.utils.helper
import java.util.*

@Entity
interface AnimeTag : Persistable {
    @get:Key
    val id: UUID

    @get:ManyToOne
    @get:ForeignKey
    val anime: Anime

    @get:ManyToOne
    @get:ForeignKey
    val tag: Tag
    val source: InfoSource
    val spoiler: Boolean

    companion object : EntityHelper<AnimeTagEntity> by helper(::AnimeTagEntity, {
        setId(UUID.randomUUID())
    })
}
